/* Krister Swenson, Mark Marron                               Spring 2003

We compair the given permutation to the identity (the corresponding labels in 
the target string are renamed so that we can compair to the
identity [1,2,3,4,...]).  
  -The insertions in the given(target) string must possess labels greater than
   the maximum in the source so that they can be identified as such.
  -The deletions(in the source but not the target) are the missing elements
   in the given(target) permutation.

Copies are renamed by the gencov code.
*/

#include <iostream>
#include "med.h"


using namespace std; 


int main()
  {
//====================== Test code =============================
  //int targ[] = {}, largest = 200;
  //int targ[] = {8,12,3,7,1,11,-8,-7,-6,6,5,9,-2,4,10}, largest = 6;
  //int targ[] = {8,12,7,11,9,-2,4,10}, largest = 7;
  //int targ[] = {3,7,1,10,6,-5,9,-2,4,8}, largest = 10;
  //int targ[] = {10,6,9,-2,4}, largest = 10;
  //int targ[] = {3,1,-7,6,5,-2,4}, largest = 6;
  //int targ[] = {-3,4,-1,-2,5}, largest = 5;
  //int targ[] = {1,2,3,4,5,6}, largest = 6;
  //int targ[] = {6,5,4,3,2,1}, largest = 6;
  //int targ[] = {1,2,-4,-3,5,6}, largest = 6;
  //int targ[] = {1,7,-6,8,9,-5,3,4,10,-2}, largest = 10;
  //int targ[] = {1,6,9,-5,3,10,-2}, largest = 10;
  //int targ[] = {-2,5,-3,1,-4,6,11,10,7,-8,9}, largest = 11;
  //int targ[] = {-2,-3,1,-4,11,10,7,9}, largest = 11;
/*
                                  //The origional sequence length.
  int targlen = sizeof(targ)/sizeof(int);
  int copstat = 0;
*/
//======================           =============================


 
  int targlen;          //The actual length of the input sequence(targ).
  int copstat;          //The number of copies that occured during evolution.
  int largest;          //The length of the identity before it was modified.
                        // (all values above this are inserted elements)
  int* targ = readInSeq(targlen, copstat, largest); //Get the sequence.

  printArray(targ, targlen);
                                                    //Rename the copies:
  int maxelem = getMax(targ, targlen);
  cerr << "MAX:" << maxelem << endl;
  int* seq = renameCopies(targ, targlen, maxelem + 10, maxelem);
  confirmRenaming(seq, targlen);
  cerr << "---------------" << getMax(targ, targlen) << endl;

  int ops = getMED(seq, targlen, largest);          //Get the Minimum Edit Dist.

  cout << "COPIES(stat from creation):" << copstat << endl;
  cout << "Ops:" << ops << endl;
  cerr << "done.\n";
  return 0;
  }
