//Krister Swenson                                                  Spring 2008
//
//Reads in one sequences containing and prints the distance from the ID using
// the O(n lg(n)) method.
//

#include <iostream>
#include "Permutation.h"
#include "../seqtools/seqfuncs.h"
#include "../graph/Ograph.h"



int main()
  {
  cout << "testing in progress..." << endl;
  int lseq = 8;
  int* seq = makeID(lseq);
  //Permutation p(seq, lseq);
  //Ograph g(seq, lseq);
  vector<int> seqv = getRandPerm(lseq);
  Permutation p(seqv);
  Ograph g(seqv);

  for(;;)
    {
    int i = random()%lseq + 1;
    int j = random()%lseq + 1;
    if(i > j)
      continue;

    //cerr << "rev(" << i << "," << j << ")" << endl;

    p.rev(i,j);
    g.revAll(i,j);

    vector<int> pv = p.getSeqVec();
    vector<int> gv = g.getSeqVec();

    //cerr << pv << endl;
    //cerr << gv << endl;
    assert(pv == gv);
    }

  free(seq);

  return 0;
  }
