/* Krister Swenson                                                  Summer 2008

Get the distribution of distances over random permutations.
*/

#include "../seqtools/seqfuncs.h"
#include "../graph/Ograph.h"

#define SIZE 5000
#define REPS 1000

using namespace std; 

int main()
  {
  vector<int> disthist; disthist.resize(SIZE);
  srandom((unsigned int)time(NULL));

  for(int i=0; i<REPS; i++)
    {
    Ograph g(getRandSPerm(SIZE));
    disthist[g.getDistNH()]++;
    }

  cout << "size:" << SIZE << " reps:" << REPS << endl;
  cout << disthist << endl;

  return(0);
  }
